%models random read noise quantization error near and below 1 LSB
i=1;                
for s = 0:0.01:3            %DN, s is read noise standard deviation 
    img = randn(200,200)*s; %DN, generate random read noise floating point analog frame
    rn(i)= std2(img);       %DN, std dev of analog image
    IMG = int8(img);        %DN, quantize image (from floating point to integer)
    RN(i)=std2(IMG);        %DN, measure std dev of simulated quantized image
    r(i) = s;               %DN, 'actual' floating point analog standard deviation   
    i=i+1;
end
%Model1 Std Deviation with simple quantization error (works well above 2/3 LSB)
modRNa = sqrt(r.^2+1/12);

%Model2 standard deviation below 2/3 LSB - above that you need DN3+
DN2 = 1/2*(1+erf(-1.5./r/sqrt(2)));     %integral of normal from -Inf to end of DN2
DN1 = 1/2*(1+erf(-0.5./r/sqrt(2)))-DN2; %integral of just DN1
modRNb = sqrt(2*(4*DN2 + DN1));         %std dev = sqrt of twice the weights

%Plot Stuff
semilogx(rn,RN./rn,'.b')
hold on
semilogx(r,modRNa./r)
semilogx(r,modRNb./r)
axis([0.2 2 0.5 1.5])
xlabel('Random Read Noise Std Deviation (LSB)')
ylabel('Ratio of Measured vs Actual Read Noise')
legend('Measured','Model1 >2/3LSB','Model2 <2/3LSB')
grid
hold off
